'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

exports['default'] = function (name, components, locals) {
  var promises = (Array.isArray(components) ? components : [components]).

  // Filter out routes without defined components
  filter(function (component) {
    return !!component;
  })

  // Get component lifecycle handler functions
  .map(function (component) {
    return { component: component, handlers: component.__redial_handlers__ };
  })

  // Filter out components that haven't been decorated
  .filter(function (_ref) {
    var handlers = _ref.handlers;
    return handlers;
  })

  // Calculate locals if required, execute handlers and store promises
  .map(function (_ref2) {
    var component = _ref2.component;
    var handlers = _ref2.handlers;

    var handler = handlers[name];

    if (typeof handler !== 'function') {
      return;
    }

    return typeof locals === 'function' ? handler(locals(component)) : handler(locals);
  });

  return Promise.all(promises);
};

module.exports = exports['default'];